=== debian/changelog ===
mupdf (1.27.0+ds1-2ubuntu1) resolute; urgency=medium

  * Disable LTO to avoid many changes to symbols file
  * Mark symbols disappearing with -O3 as optional

 -- Graham Inggs <ginggs@ubuntu.com>  Tue, 27 Jan 2026 18:53:09 +0000
