=== debian/control ===
Source: mupdf
Section: text
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Kan-Ru Chen (陳侃如) <koster@debian.org>
Uploaders: Daniel Echeverri <epsilon@debian.org>
Build-Depends: afdko-bin:native,
               debhelper-compat (= 13),
               fonts-droid-fallback,
               fonts-noto-cjk,
               fonts-noto-core,
               fonts-noto-ui-core,
               fonts-sil-charis,
               fonts-urw-base35,
               freeglut3-dev,
               furo,
               libgl-dev,
               libfreetype-dev,
               libgumbo-dev,
               libharfbuzz-dev,
               libjbig2dec0-dev (>= 0.20),
               libjpeg-dev,
               liblcms2-dev,
               libmujs-dev (>= 1.3.8),
               libopenjp2-7-dev,
               libssl-dev,
               libx11-dev,
               libxext-dev,
               libxrandr-dev,
               libbrotli-dev,
               libzxing-dev,
               pkgconf,
	       dh-sequence-python3,
               python3-all-dev,
               python3-clang,
               python3-docutils,
               python3-roman,
               python3-pygments,
               python3-sphinx-copybutton,
               python3-sphinx-rtd-theme,
               python3-myst-parser,
	       python3-sphinx,
               rst2pdf,
               swig,
               texlive-fonts-extra,
               unzip,
               zlib1g-dev
Standards-Version: 4.7.2
Homepage: https://mupdf.com/
Vcs-Git: https://salsa.debian.org/debian/mupdf.git
Vcs-Browser: https://salsa.debian.org/debian/mupdf

Package: libmupdf-dev
Architecture: any
Section: libdevel
Depends: libfreetype-dev, libmupdf27.0 (= ${binary:Version}), ${misc:Depends}
Built-Using: ${Built-Using}
Description: development files for the MuPDF viewer
 MuPDF is a lightweight PDF viewer and toolkit written in portable C.
 It also reads XPS, OpenXPS and ePub documents.
 .
 This package contains the static the unversioned library and headers.

Package: libmupdf27.0
Architecture: any
Section: libs
Depends: libjbig2dec0 (>= 0.19), ${misc:Depends}, ${shlibs:Depends}
Built-Using: ${Built-Using}
Description: shared library for the MuPDF viewer
 MuPDF is a lightweight PDF viewer and toolkit written in portable C.
 It also reads XPS, OpenXPS and ePub documents.
 .
 This package contains the shared library libmupdf and libmupdfcpp.

Package: mupdf
Architecture: any
Depends: libjbig2dec0 (>= 0.19),
         libjs-sphinxdoc,
         libmupdf27.0 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
	     ${sphinxdoc:Depends}
Built-Using: ${Built-Using}
Suggests: mupdf-tools
Provides: pdf-viewer
Description: lightweight PDF viewer
 MuPDF is a lightweight PDF viewer and toolkit written in portable C.
 It also reads XPS, OpenXPS and ePub documents.
 .
 The renderer in MuPDF is tailored for high quality anti-aliased graphics.
 It renders text with metrics and spacing accurate to within fractions of a
 pixel for the highest fidelity in reproducing the look of a printed page
 on screen.

Package: mupdf-tools
Architecture: any
Depends: libjbig2dec0 (>= 0.19),
         libmupdf27.0 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: command line tools for the MuPDF viewer
 MuPDF is a lightweight PDF viewer and toolkit written in portable C.
 It also reads XPS, OpenXPS and ePub documents.
 .
 This package contains command line tools using the MuPDF library:
  - mutool - tool for clean, extract, inspect PDF documents and
             render PDF/XPS/CBZ documents.

Package: python3-mupdf
Architecture: any
Depends: libmupdf27.0 (= ${binary:Version}), ${python3:Depends}, ${misc:Depends}, ${shlibs:Depends}
Description: Python bindings for MuPDF library
 MuPDF is a lightweight PDF viewer and toolkit written in portable C.
 It also reads XPS, OpenXPS and ePub documents.
 .
 This package contains the contains low level mupdf Python bindings.
