=== debian/watch ===
version=4
opts="repacksuffix=+ds1,\
searchmode=plain,\
dversionmangle=s/\+ds\d*$//,\
downloadurlmangle=s|.*mupdf-([\d.]+)-source\.tar\.gz|https://casper.mupdf.com/downloads/archive/mupdf-$1-source.tar.gz|,\
filenamemangle=s/.*mupdf-(.+)-source\.tar\.gz/mupdf-$1.tar.gz/" \
https://mupdf.com/releases?product=MuPDF \
mupdf-([\d.]+)-source\.tar\.gz
